Redmine - Defect #14009

Issue Editing/Viewing - ASCII-8BIT/UTF-8 Problems
2013-05-08 11:03 - Roger Giriffiths

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: 118n Estimated time: 0.00 hour
Target version:

Resolution: Invalid Affected version: 2.3.0
Description

System Configuration

e OS: openSUSE 12.3

e Redmine: 2.3.0

¢ Rails: 3.2.13

¢ Ruby: 1.9.3p392
Database: MariaDB 5.5.29

Log File Extract

¢ ActionView::TemplateError (incompatible character encodings: ASCII-8BIT and UTF-8)
o app/views/issues/show.html.erb:120

Description
I am unable to access a ticket after entering an update to the ticket including the following characters:-

Superscript Two - U+00B2

Greek Small Letter Lambda - U+03BB
Greek Small Letter Pi - U+03C0
Greek Small Letter Sigma - U+03C3

| received an e-mail from Redmine indicating that these values had been accepted by the system as entered however | am no longer
able to view the ticket view/edit the Redmine interface.

History

#1 - 2013-05-08 11:06 - Jean-Baptiste Barth

- Status changed from New to Needs feedback

Can you show us a more complete stack trace ? The mentionned line is just a reference to an other view, maybe the full trace will include more
informations about where the problem is so we can investigate better.

#2 - 2013-05-08 11:06 - Roger Griffiths
Potentially related to #13852, #13520, #13240, and various other tickets.

#3 - 2013-05-08 11:08 - Roger Griffiths

Problem is that | have to type the stack trace, so it gets awkward.

#4 - 2013-05-08 11:09 - Jean-Baptiste Barth

OK. Can you see SubmittingBugs and give us the requested informations about your redmine instance (I'm especially interested in your "mysql" gem
version, and your database encoding if you have it).

#5 - 2013-05-08 11:11 - Roger Griffiths

Only two more levels to the stack trace:-

e app/controllers/issues_controller.rb:119
e app/controllers/issues_controller.rb:116
https://www.redmine.org/issues/13852
https://www.redmine.org/issues/13520
https://www.redmine.org/issues/13240
https://www.redmine.org/projects/redmine/wiki/SubmittingBugs

#6 - 2013-05-08 11:24 - Roger Griffiths

Database was created using UTF-8 as per your Wiki.
Gems will be as per normal for openSUSE 12.3 (updated about 1-2wks ago) or that installed by redmine-2.3.0.
According to: gem list MySQL

* mysql (2.9.0, 2.8.1)
e mysql2 (0.3.11)

#7 - 2013-05-08 11:30 - Roger Griffiths

See original report above for all information explicitly mentioned in SubmittingBugs (except the complete stack trace which has been supplemented
as requested).

#8 - 2013-05-08 11:55 - Roger Griffiths

According to an SQL dump (field notes in table redmine.journals) the database encodings for the characters in question are:-

e Superscript Two - \302\262

e Greek Small Letter Lambda - \316\273
e Greek Small Letter Pi - \317\200

e Greek Small Letter Sigma - \317\203

#9 - 2013-05-08 12:12 - Roger Griffiths

Worked around issue by replacing UTF-8 characters with pure ASCII alternatives.

This should NOT be an issue with a system that accepts and even promotes usage of UTF-8 characters.

#10 - 2013-05-08 12:35 - Toshi MARUYAMA

Check your database encoding is UTF-8.
See:
http://www.redmine.org/boards/1/topics/36573?r=36629#message-36629

#11 - 2013-05-08 14:29 - Santosh Rathod
- File 10250113.jpg added

Hello,

Test

#12 - 2013-05-08 14:50 - Daniel Felix
- File deleted (10250113.jpg)

#13 - 2013-05-09 17:13 - Roger Griffiths
Database encoding is confirmed as UTF-8.
The encoding previously mentioned was in an ASCII encoded SQL dump file.
When | manually updated the database | used the raw Unicode characters in my SQL statements.
#14 - 2013-05-12 03:03 - Toshi MARUYAMA
Roger Griffiths wrote:
Database encoding is confirmed as UTF-8.
The encoding previously mentioned was in an ASCII encoded SQL dump file.

When | manually updated the database | used the raw Unicode characters in my SQL statements.

Have you resolved the problem?

#15 - 2013-05-13 12:19 - Roger Giriffiths

No - | have worked around it with a kludge.

The reported issue still needs to be resolved.
http://www.redmine.org/boards/1/topics/36573?r=36629#message-36629

#16 - 2013-05-13 12:45 - Toshi MARUYAMA

Did you check "show session variables like ‘char%" and "show global variables like 'char%';"?
http://www.redmine.org/boards/1/topics/36573?r=36624#message-36624

Why do you use MariaDB?
Is MariaDB compatible with MySQL client (Ruby mysql2 adapter)?

#17 - 2013-05-18 11:11 - Roger Griffiths
MariaDB is the default database installation for openSUSE 12.3 and is a compatible enhancement of MySQL (i.e. a drop in replacement).

| am a programmer myself and have double checked my installation before reporting the issue here. | hate it when users report problems without
doing such checks themselves first.

The database is running fine and processing UTF-8 correctly, the Ruby code would appear to be at fault based on my limited investigation (/ do not
have the time to look into it and fix it myself).

#18 - 2013-05-30 09:42 - Roger Griffiths

Test Case 1 : m.0.A.x2

#19 - 2013-05-30 09:42 - Roger Griffiths

Test Case 2 : m2.02.\2

#20 - 2013-05-30 09:44 - Roger Griffiths

As the issue does not appear to occur with the main Redmine server what component/software versions are being used for THIS site.

#21 - 2013-05-30 09:45 - Roger Griffiths

Test Case 3 : MO2.0A2.TIA2

#22 - 2013-09-01 23:29 - Jan Niggemann (redmine.org team member)
Toshi MARUYAMA wrote:

Is MariaDB compatible with MySQL client (Ruby mysql2 adapter)?

MariaDB is a drop-in replacement for MySQL, it's a fork of MySQL created by its own inventor (Monty widenius) after he left Oracle. There shouldn't
be any issues using MariaDB instead of MySQL, except that the gem needs to be compatible with the db-client-lib version.

#23 - 2014-01-04 00:50 - Domingo Galdos

We had the same issue using the current latest stable redmine version.
We have a patch to fix it (below)

| had the same issue with Redmine, after upgrading from ruby 1.8.x to ruby 2.0.x. It turned out that indeed, an unrecognized character had been
pasted in by a user (in our case it was "D"), and the GUI allows this even though it causes this issue. Correcting the field in the database fixes it.

A more permanent fix is to follow the advice from http:/stackoverflow.com/a/5233939/368503 and add an initializer that monkeypatches the mysql lib
to automatically re-encode problematic strings so the issue never hits Rails or Redmine. | tested this in our configuration successfully. Our
configuration is:

ruby 2.0.0-p353 (2013-11-22) [x86_64-linux]

redmine 2.4.1.stable

passenger 4.0.30

bundler 1.2.4

rails 3.2.15

Database: mysqgld Ver 5.0.77 for redhat-linux-gnu on x86_64 (Source distribution)

Let me know if any more information is needed to vet this before moving forward or anything else | should be aware of as this is my first time
contributing bugfixes back upstream to Redmine.

#24 - 2014-01-04 03:32 - Domingo Galdos

Turns out switching to the mysql2 adapter (instead of the mysql adapter) by changing one line of database.yml is a much simpler and more complete
fix. So disregard the solution mentioned above.

Nevertheless, given that the newer version combinations of Redmine/dependencies work so badly with the mysql adapter, perhaps a deprecation
warning could be added? Would have saved me a bunch of time, and I'm neither the first nor last to run into this issue. Does that sound reasonable,
or some other such solution to avoid anyone wasting more than a couple minutes on this issue again? Thanks!
http://www.redmine.org/boards/1/topics/36573?r=36624#message-36624
https://mariadb.org
https://kb.askmonty.org/en/mariadb-versus-mysql-compatibility/
#25 - 2024-01-21 12:54 - Go MAEDA
- Status changed from Needs feedback to Closed

- Resolution set to Invalid

According to #note-24, the error was resolved by changing the database adapter from mysql to mysgl2. Closing this issue.
